using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;
using Infragistics.Win.UltraWinGrid;
using System.Diagnostics;
using Infragistics.Win.CalcEngine;

namespace WindowsApplication15
{
    public partial class Form1 : Form
    {
        public Form1()
        {
            InitializeComponent();
        }

        private void ultraGrid1_InitializeLayout(object sender, Infragistics.Win.UltraWinGrid.InitializeLayoutEventArgs e)
        {
            // Add a simple summary to the first grid. 
            // Note that this column must use a formula summary. I can't use a summary of type Sum
            // because of the bug mentioned below where you can't reference a summary value from
            // anothe grid in a formula. 
            e.Layout.Bands[0].Summaries.Add(
                "Summary In Grid 1",
                "Sum([//ultraGrid1/Band 0/Column 0])", //Note that we have to use a fully-qualified reference here so that when we copy this formula into the second grid, it still refers to this grid.
                 Infragistics.Win.UltraWinGrid.SummaryPosition.UseSummaryPositionColumn,
                e.Layout.Bands[0].Columns["Column 0"]);
        }

        private void ultraGrid2_InitializeLayout(object sender, Infragistics.Win.UltraWinGrid.InitializeLayoutEventArgs e)
        { 
            // Add a simple summary to the second grid. 
            e.Layout.Bands[0].Summaries.Add(
                "Summary In Grid 2",
                "Sum([Column 0])",
                Infragistics.Win.UltraWinGrid.SummaryPosition.UseSummaryPositionColumn,
                e.Layout.Bands[0].Columns["Column 0"]);            

            // Get a reference to the SummarySettings for the summary in each grid. 
            SummarySettings mySummarySettings = e.Layout.Bands[0].Summaries["Summary In Grid 2"];
            SummarySettings otherGridSummarySettings = this.ultraGrid1.DisplayLayout.Bands[0].Summaries["Summary In Grid 1"];

            // Theoretically, this should work. But for some reason, trying to reference the 
            // summary in the first grid in a formula in the second grid causes an exception. 
            //string formula = string.Format(
            //    "[{0}] + [{1}]",
            //    this.GetSummaryReferenceName(mySummarySettings),
            //    this.GetSummaryReferenceName(otherGridSummarySettings)
            //    );

            // Now build a formula that sums the two summaries.            
            string formula = string.Format(
                "[{0}] + {1}",
                this.GetSummaryReferenceName(mySummarySettings),
                otherGridSummarySettings.Formula // Since we can't reference the summary in the first grid directly, we can simply repeat the formula in this formula.
                );

            // Add a second summary to this second grid with the formula we just built. 
            e.Layout.Bands[0].Summaries.Add(
                            formula,
                            Infragistics.Win.UltraWinGrid.SummaryPosition.UseSummaryPositionColumn,
                            e.Layout.Bands[0].Columns["Column 0"]);
        }

        // The reference name of the summary does not use the Key of that Summary. So
        // get the AbsoluteName of the reference the hard way. 
        private string GetSummaryReferenceName(SummarySettings summarySettings)
        {
            IFormulaProvider formulaProvider = summarySettings as IFormulaProvider;
            return formulaProvider.Reference.AbsoluteName;
        }
    }
}